

#include <iostream>
#include <math>
#include <conio>

using namespace std;

// classe Punto
class Punto
{
     float x;     // le coordinate x e y definiscono lo stato di un punto
     float y;

     public:        // metodi pubblici

     // metodi che rendono le coordinate x o y
     float dai_x()
     {
         return(x);
     }

     float dai_y()
     {
         return(y);
     }

     // fissa la posizione di un punto
     void setta_punto(float xp, float yp)
     {
         x = xp;
         y = yp;
     }

     // calcola la distanza tra due punti
     float distanza_punti(Punto p)
     {
         float d;

         d = sqrt(pow(x - p.x,2) + pow(y - p.y,2));

         return(d);
     }
};

// segmento - classe che utilizza oggetti Punto

class Segmento 
{
    Punto p1, p2;    // la posizione del segmento e' definita dalle
                     // caratteristiche di due punti 
    public:

    // fissa la posizione del segmento tramite
    // la definizione della posizione di due punti
    void definisci_segm(Punto pnt1, Punto pnt2)
    {
        p1.setta_punto(pnt1.dai_x(), pnt1.dai_y());
        p2.setta_punto(pnt2.dai_x(), pnt2.dai_y());
    }

    // calcolo della lunghezza del segmento
    float lunghezza()
    {
        return(p1.distanza_punti(p2));
    }
};

// classe che utilizza oggetti Punto e Segmento
class Rettangolo 
{
    Segmento s1, s2, s3, s4;

    public:

    // rettangolo definito con punti estremi
    // in alto a sinistra ed in basso a destra
    void definisci_rett(Punto pnt1, Punto pnt2)
    {
        Punto pincr1, pincr2;

        // definisce due punti all' incrocio delle coordinate
        // dei punti definenti il rettangolo
        pincr1.setta_punto(pnt2.dai_x(),pnt1.dai_y());
        pincr2.setta_punto(pnt1.dai_x(),pnt2.dai_y());

        // dati i punti iniziali e di incrocio
        // si passa alla definizione dei segmenti (lati)  
        s1.definisci_segm(pnt1, pincr1);
        s2.definisci_segm(pincr1, pnt2);
        s3.definisci_segm(pnt2, pincr2);
        s4.definisci_segm(pincr2, pnt1);
    }

    // calcolo del perimetro
    float perimetro()
    {
        return(s1.lunghezza() + s2.lunghezza() + s3.lunghezza() + s4.lunghezza());
    }

    // calcolo dell' area
    float area()
    {
        return(s1.lunghezza() * s2.lunghezza());
    }

    // calcolo della diagonale del rettangolo
    float diagonale()
    {
        float ld;

        ld =  sqrt(pow(s1.lunghezza(),2) + pow(s2.lunghezza(),2));

        return(ld);
    }
};

int main()
{
    Punto p1, p2;
    Rettangolo r;    // oggetto Rettangolo

    // si fissano i punti che definiscono il rettangolo
    p1.setta_punto(2,3);
    p2.setta_punto(5,7);

    // si definisce il rettangolo in base a quei punti
    r.definisci_rett(p1, p2);

    // si calcolano, come al solito, perimetro, area e diagonale
    // tramite opportuni metodi della classe Rettangolo
    cout << "Il perimetro del rettangolo e':  " << r.perimetro() << endl;
    cout << "L'area del rettangolo e':  " << r.area() << endl;
    cout << "La diagonale del rettangolo e':  " << r.diagonale() << endl;

    getch();        // prosegue solo se si preme un qualunque tasto 

    return(0);    

}


